export function diffKeys() {
  var prevKeys = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var currentKeys = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var list = [];
  var currentIndex = 0;
  var currentLen = currentKeys.length;

  // Check prev keys to insert or keep
  prevKeys.forEach(function (key) {
    var hit = false;

    for (var i = currentIndex; i < currentLen; i += 1) {
      var currentKey = currentKeys[i];
      if (currentKey === key) {
        // New added keys should add before current key
        if (currentIndex < i) {
          list = list.concat(currentKeys.slice(currentIndex, i).map(function (addKey) {
            return { key: addKey, add: true };
          }));
          currentIndex = i;
        }
        list.push({
          key: key,
          keep: true
        });
        currentIndex += 1;

        hit = true;
        break;
      }
    }

    // If not hit, it means key is removed
    if (!hit) {
      list.push({
        key: key,
        remove: true
      });
    }
  });

  // Add rest to the list
  if (currentIndex < currentLen) {
    list = list.concat(currentKeys.slice(currentIndex).map(function (addKey) {
      return { key: addKey, add: true };
    }));
  }

  return list;
}

export default diffKeys;